image: docker:19.03.12

services:
  - docker:19.03.12-dind

variables:
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: '/certs'
  DOCKER_DRIVER: overlay2

  # Docker Image names
  IMAGE_NAME: '$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA'
  IMAGE_NAME_LATEST: '$CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME-latest'

stages:
  - build
  - build-image

build: 
  stage: build
  image: node:latest
  before_script:
    - npm ci
  script:
    - npm run build
  artifacts:
    paths:
      - dist
      - node_modules

build-image:
  stage: build-image
  dependencies:
    - build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker pull $IMAGE_NAME_LATEST || true
    - docker build --compress --cache-from $IMAGE_NAME_LATEST --tag $IMAGE_NAME --tag $IMAGE_NAME_LATEST .
    - docker push $IMAGE_NAME
    - docker push $IMAGE_NAME_LATEST
  after_script:
    - docker images
